{% extends "baseAjaxTable.html" %}
{% block content %}
<button  data-toggle="modal" class="btn btn-danger btn-del" data-target="#modalSupprimer">Supprimer la ligne</button>
<button type="button" data-target="#ModalPoneyForm" class="btn btn-secondary btn-add" data-toggle="modal" >Ajouter un Poney</button>
<button type="button" class="btn btn-secondary btn-edit" data-toggle="modal" data-target="#ModalModifPoneyForm"> Modifier le Poney</button>
<button type="button" id="btn-filtre" class="btn btn-secondary" data-toggle="modal" data-target="#ModalPoneyFormFiltre"> Filtrer</button>


  <table id="data" class="table table-striped display table-bordered">
    <thead>
      <tr>
        <th>ID</th>
        <th>Nom</th>
        <th>Poids Supporté</th>
        <th>Race</th>
        <th>Robe</th>
      </tr>
    </thead>
    <tbody>

    </tbody>
  </table>
  <!--Modal s'affichant lors du clique de supprimer pour savoir si on veut vraiment supprimer-->
  <div class="modal fade" id="modalSupprimer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Supprimer</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Etes-vous sur de vouloir supprimer ce Poney ?</p>
          <span id="poneysup"></span>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
          <button type="button" class="btn btn-danger" id="deletePoney" data-dismiss="modal">Supprimer</button>
          
        </div>
      </div>
    </div>
</div>



<div id="ModalPoneyForm" class="modal fade modal-poney" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Ajouter un Poney</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{url_for('save_poney')}}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Ajouter">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<div id="ModalModifPoneyForm" class="modal fade modal-poney" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Modifier le Poney</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{url_for('edit_poney')}}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Modifier">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
 
<div id="ModalPoneyFormFiltre" class="modal fade modal-poney" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Filtrer</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST">
                {% for field in form_filtre.get_form_field() %}
                    <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                        {{ form_filtre[field].label }} {{ form_filtre[field](size=50, class_="form-control") }}
                    </div>
                    {% if form_filtre[field].errors %}
                        <ul class="list-group">
                            {% for e in form_filtre[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <button type="button" id="btn-filtre-save" class="btn btn-secondary" data-toggle="modal" data-target="#ModalPoneyFormFiltre"> Filtrer</button>
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->

{% endblock %}

{% block scripts %}
  <script>
    let row = null;
    $(document).ready(function(){
      let open_modal = '{{open_modal}}';
      if (open_modal) {
        $('#ModalPoneyForm').modal('show');
      }
      let open_modal_edit = '{{open_modal_edit}}';
      if (open_modal_edit) {
        $('#ModalModifPoneyForm').modal('show');
      }

      $(".btn-edit").prop("disabled",true);
      $(".btn-del").prop("disabled",true);
      let table = $('#data').DataTable({
        
        ajax:{
              url:'/api/data/poney',
                type:"POST",
                data:function(pon){
                    if(pon!=undefined){
                      pon.nom_poney_filtre = $("#nom_poney_filtre").val();
                      pon.poidssup_filtre = $("#poidssup_filtre").val();
                      pon.race_filtre = $("#race_filtre").val();
                      pon.robe_filtre = $("#robe_filtre").val();
                  }
                  return pon
                }
        },
        columns: [
          {data: 'idpo'},
          {data: 'nom_poney', searchable: true},
          {data: 'poidssup', searchable: true},
          {data: 'race', searchable: true},
          {data: 'robe', searchable: true}
        ],
      
        
      });

       $("#data").on("click", "tr", function() {
            if(row !=null){
                $(row).css('background-color', "");     
            }
            $("#buttonSupr").prop("disabled",false)
            row = this;
            $(".btn-edit").prop("disabled",false);
            $(".btn-del").prop("disabled",false);
            $(this).css('background-color', "#AFE1AF");
            $("#poneysupprimer").html($(row)[0].childNodes[1].innerHTML+ " " + $(row)[0].childNodes[2].innerHTML)
        });

        $("#deletePoney").on("click",function(){
            $.ajax({
                url:'{{url_for("delete_poney")}}',
                type:'POST',
                data:{id:$(row)[0].childNodes[0].innerHTML},
            success: function(){
                table.ajax.reload();
                } 
            });       
        });

        $("#data").on("dblclick", "tr", function() {
          row = this;
          let idPoney = row.childNodes[0].innerHTML;
          window.location.href = "{{ url_for('detail_poney', id='idPoney') }}".replace("idPoney",idPoney) ;
        });

        $(document).on('click', '.btn-edit', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalModifPoneyForm #idpo').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifPoneyForm #nom_poney').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifPoneyForm #poidssup').val($(row)[0].childNodes[2].innerHTML);
          $('#ModalModifPoneyForm #race').val($(row)[0].childNodes[3].innerHTML);
          $('#ModalModifPoneyForm #robe').val($(row)[0].childNodes[4].innerHTML);
      
          // Afficher le modal
          $('#ModalModifPoneyForm').modal('show');
        });

        $(document).on('click', '.btn-add', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalPoneyForm #idpo').val("");
          $('#ModalPoneyForm #nom_poney').val("");
          $('#ModalPoneyForm #poidssup').val("");
          $('#ModalPoneyForm #race').val("");
          $('#ModalPoneyForm #robe').val("");
          // Afficher le modal
          $('#ModalPoneyForm').modal('show');

          let errorElements = document.getElementsByClassName("list-group-item-danger");

          // Loop through the elements and remove the li element
          while(errorElements.length > 0){
            errorElements[0].parentNode.removeChild(errorElements[0]);
          }
          
        });

        $("#btn-filtre-save").on("click",function(){
          table.ajax.reload();
          $("#ModalPoneyFormFiltre").modal("hide");
        });
        $("#btn-filtre").on("click",function(){
            $("#ModalPoneyFormFiltre").modal("show");
        });
     

    });




   
 



    
  </script>
{% endblock %}
<!--
  https://datatables.net/examples/api/select_single_row.html
  https://blog.miguelgrinberg.com/post/beautiful-interactive-tables-for-your-flask-templates-->